unit MGVirtIntf;

interface

uses classes;

const
 DllEntyPointName = 'MGDirectDllEntry001';

type
 TMGInterface = class (TObject)
 end;

 TMGIProcServerIntf = class (TMGInterface)
 public
  function  Execute (Values: array of const):variant;virtual;stdcall;abstract;
  function  GetProcName:String;virtual;stdcall;abstract;
  function  GetComment:String;virtual;stdcall;abstract;
  function  GetGroup:string;virtual;stdcall;abstract;
  function  GetIcon:Integer;virtual;stdcall;abstract;
  function  GetVisible:boolean;virtual;stdcall;abstract;
  function  GetEnabled:boolean;virtual;stdcall;abstract;
  function  GetCanClose:boolean;virtual;stdcall;abstract;
  function  GetProperty(Prop:string):variant;virtual;stdcall;abstract;
  procedure SetProperty(Prop:string; value:variant);virtual;stdcall;abstract;
  procedure NotifyClients(Event:string; value:variant);virtual;stdcall;abstract;
  procedure NotifyEnabled(isEnabled:boolean);virtual;stdcall;abstract;
  procedure Register;virtual;stdcall;abstract;
  procedure UnRegister;virtual;stdcall;abstract;
 end;

 TMGIProcClientIntf = class (TMGInterface)
 public
  function  GetProcName:string;virtual;stdcall;abstract;
  function  GetEnabled:boolean;virtual;stdcall;abstract;
  procedure OnEnabledChange(IsAvailable:boolean);virtual;stdcall;abstract;
  procedure OnServerEvent(Event:string; const value:variant);virtual;stdcall;abstract;
  procedure Register;virtual;stdcall;abstract;
  procedure UnRegister;virtual;stdcall;abstract;
 end;

 TMGIDllServicesIntf = class (TMGInterface)
 public
  procedure RegisterDll;virtual;stdcall;abstract;
  procedure UnRegisterDll;virtual;stdcall;abstract;
  function  GetAuthor:string;virtual;stdcall;abstract;
  function  GetComment:String;virtual;stdcall;abstract;
  function  GetCaption:String;virtual;stdcall;abstract;
  function  GetVersion:string;virtual;stdcall;abstract;
  function  GetIDString:string;virtual;stdcall;abstract;
  function  GetType:string;virtual;stdcall;abstract;
  function  GetIcon:Integer;virtual;stdcall;abstract;
 end;

 TMGIApplicationServicesIntf = class (TMGInterface)
 public
  function  GetApplicationHInstance:integer;virtual;stdcall;abstract;
  procedure RegisterServer(Proc:TMGIProcServerIntf);virtual;stdcall;abstract;
  procedure RegisterClient(Proc:TMGIProcClientIntf);virtual;stdcall;abstract;
  procedure UnRegisterServer(Proc:string);virtual;stdcall;abstract;
  procedure UnRegisterClient(Proc:TMGIProcClientIntf);virtual;stdcall;abstract;
  procedure NotifyClients(Proc,Event:string; value:variant);virtual;stdcall;abstract;
  procedure NotifyEnabled(Proc:string; value:boolean);virtual;stdcall;abstract;
  function  ExecuteServer(Proc:string; const Values: array of const):variant;virtual;stdcall;abstract;
  function  GetServer(Proc:string):TMGIProcServerIntf;virtual;stdcall;abstract;
  function  GetServerEnabled(Proc:string):boolean;virtual;stdcall;abstract;
  function  GetServerProperty(Proc,Prop:string):variant;virtual;stdcall;abstract;
  procedure SetServerProperty(Proc,Prop:string; value:variant);virtual;stdcall;abstract;
 end;

 TMGDllEntryPointProc = procedure (IApp : TMGIApplicationServicesIntf; var IDll : TMGIDllServicesIntf);stdcall;

var
 MGDirectDllApplication : TMGIApplicationServicesIntf;

implementation

end.
